package com.sun.corba.se.impl.resolver;

import java.util.HashSet;
import java.util.Set;
import org.omg.CORBA.Object;
import com.sun.corba.se.spi.resolver.Resolver;

public class CompositeResolverImpl implements Resolver
{
    private Resolver first;
    private Resolver second;
    
    public CompositeResolverImpl(Resolver first, Resolver second) {
        this.first = first;
        this.second = second;
    }
    
    public org.omg.CORBA.Object resolve(String s) {
        org.omg.CORBA.Object object = this.first.resolve(s);
        if (object == null) {
            object = this.second.resolve(s);
            return object;
        }
        return object;
    }
    
    public Set list() {
        HashSet<Object> set = new HashSet();
        set.addAll(this.first.list());
        set.addAll(this.second.list());
        return set;
    }
}
